SystemOrganization addCategory: #'GT-Examples-UI'!

!Class methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:20'!
gtInspectorGTExamplesIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list 
		title: 'Examples';
		display: [ self gtExamples ];
		icon: [:each | each icon];
		format: [:each | each gtDisplayString ];
		in: [ :list | list sorted: [ :a :b | (list format cull: a) < (list format cull: b)] ];
		send: [ :each | each returnValue ];
		when: [ self gtExamples notEmpty ]! !

AbstractMethodIconAction subclass: #GTAbstractExampleNautilusActionButton
	instanceVariableNames: ''
	classVariableNames: 'CurrentAction'
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTAbstractExampleNautilusActionButton class methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2016 23:32'!
currentAction
	^ CurrentAction ifNil: [ CurrentAction := GTExampleNautilusActionButton ]! !

!GTAbstractExampleNautilusActionButton class methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2016 23:32'!
currentAction: anObject
	MethodWidget methodsIconsCache removeAll.
	CurrentAction := anObject! !

!GTAbstractExampleNautilusActionButton class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:04'!
iconForMethod: aCompiledMethod result: aResult
	aResult
		ifNil: [ ^ Smalltalk ui icons iconNamed: #testNotRunIcon ].
	aResult isSuccess
		ifTrue: [ ^ Smalltalk ui icons iconNamed: #testGreenIcon ].
	aResult isFailure
		ifTrue: [ ^ Smalltalk ui icons iconNamed: #testYellowIcon ].
	aResult isError
		ifTrue: [ ^ Smalltalk ui icons iconNamed: #testRedIcon ].
	^ Smalltalk ui icons iconNamed: #testNotRunIcon! !

!GTAbstractExampleNautilusActionButton class methodsFor: 'testing' stamp: 'StefanReichhart 7/13/2016 22:49'!
isAbstract
	^ self == GTAbstractExampleNautilusActionButton ! !

!GTAbstractExampleNautilusActionButton class methodsFor: 'testing' stamp: 'StefanReichhart 7/13/2016 23:32'!
isEnabled
	^ self currentAction == self! !

!GTAbstractExampleNautilusActionButton class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:35'!
methodUpdated: aCompiledMethod with: aResult
	self currentAction ifNil: [ ^ self ].
	
	[ self currentAction methodUpdated: aCompiledMethod with: aResult ]
		on: Error
		do: [ " ignore " ].
	
	[ NautilusUI allSubInstances do: #updateCategoryAndMethodList ]
		on: Error 
		do: [ " ignore " ]! !

!GTAbstractExampleNautilusActionButton methodsFor: 'order' stamp: 'StefanReichhart 7/13/2016 22:51'!
actionOrder
	"Return the priority of this action"
	
	^ 0! !

!GTAbstractExampleNautilusActionButton methodsFor: 'order' stamp: 'StefanReichhart 7/13/2016 23:33'!
isActionHandled
	^ self class isAbstract not 
		and: [ self class isEnabled
			and: [ method isGTExampleMethod ] ]! !

GTAbstractExampleNautilusActionButton subclass: #GTExampleNautilusActionButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleNautilusActionButton class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:07'!
methodUpdated: aCompiledMethod with: aResult
	MethodWidget methodsIconsCache 
		at: aCompiledMethod 
		ifPresent: [ :holder | 
			holder labelGraphic: (self iconForMethod: aCompiledMethod result: aResult) ]! !

!GTExampleNautilusActionButton methodsFor: 'order' stamp: 'StefanReichhart 7/13/2016 23:10'!
privateActionIcon
	"Return the icon for this action"
	^ IconicButton new
		target: self;
		actionSelector: #run:;
		arguments: { method };
		labelGraphic: (self class iconForMethod: method result: nil);
		color: Color transparent;
		helpText: 'Run';
		extent: 16 @ 16;
		borderWidth: 0! !

!GTExampleNautilusActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 22:14'!
run: aCompiledMethod
	aCompiledMethod gtExample ifNotNil: [ :example | 
		example result ifNotNil: [ :result |
			result isSuccess 
				ifTrue: [ result returnValue inspect ]
				ifFalse: [ example debug ] ] ]! !

GTAbstractExampleNautilusActionButton subclass: #GTExampleNautilusDualActionButton
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleNautilusDualActionButton class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:07'!
methodUpdated: aCompiledMethod with: aResult
	MethodWidget methodsIconsCache 
		at: aCompiledMethod 
		ifPresent: [ :array | 
			array second labelGraphic: (self iconForMethod: aCompiledMethod result: aResult) ]! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:16'!
actionInspectExample
	^ IconicButton new
		target: self;
		actionSelector: #inspectExample:;
		arguments: { method };
		color: Color transparent;
		helpText: 'Inspect Example';
		extent: 16 @ 8;
		borderWidth: 0! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:15'!
actionInspectReturnValue
	^ IconicButton new
		target: self;
		actionSelector: #inspectReturnValue:;
		arguments: { method };
		color: Color transparent;
		helpText: 'Inspect Return-Value';
		extent: 16 @ 8;
		borderWidth: 0! !

!GTExampleNautilusDualActionButton methodsFor: 'order' stamp: 'StefanReichhart 7/13/2016 22:54'!
actionStateToCache
	"Return the state of the icon for caching purpose"
	^ result 
		ifNil: [ super actionStateToCache ]
		ifNotNil: [ self exampleStateToCache ]! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 22:58'!
actions
	| action1 action2 |
	^ result := ((Morph new
		extent: 16@16;
		color: Color transparent;
		borderWidth: 0;
		changeTableLayout;
		listDirection: #topToBottom;
		addMorph: (action1 := self actionInspectExample);
		addMorph: (action2 := self actionInspectReturnValue);
		yourself) -> { action1. action2 })! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 22:54'!
exampleStateToCache
	^ {
		IconicButtonStateHolder forNautilus: result value first. 
		IconicButtonStateHolder forNautilus: result value second } ! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:03'!
inspectExample: aCompiledMethod
	aCompiledMethod gtExample 
		ifNotNil: [ :example | example inspect ]
		ifNil: [ self notifyNoExample: aCompiledMethod ]! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:01'!
inspectReturnValue: aCompiledMethod
	aCompiledMethod gtExample 
		ifNotNil: [ :example | 
			example result 
				ifNotNil: [ :exampleResult |
					exampleResult isSuccess 
						ifTrue: [ result returnValue inspect ]
						ifFalse: [ example debug ] ] ]
		ifNil: [ self notifyNoExample: aCompiledMethod ]! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 23:02'!
notifyNoExample: aCompiledMethod
	GrowlMorph 
		openWithLabel: 'No valid example in'
		contents: aCompiledMethod gtDisplayString! !

!GTExampleNautilusDualActionButton methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 22:58'!
privateActionIcon
	^ self actions key! !

!SmalltalkImage methodsFor: '*GT-Examples-UI' stamp: 'TudorGirba 8/22/2016 03:19'!
gtInspectorExamplesContainedIn: composite
	<gtInspectorPresentationOrder: 0>
	composite table
		title: 'Examples';
		display: [ self gtExamplesContained ];
		column: 'Example' evaluated: [ :each | each gtDisplayString ];
		column: 'Subject' evaluated: [ :each | ', ' join: (each subjects collect: [:s | s gtDisplayString ]) ]! !

!SmalltalkImage methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/3/2016 15:47'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
		title: 'Examples';
		allCandidates: [ self gtExamplesContained ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring! !

!GTSpotter methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 20:58'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 41>
	aStep listProcessor
		title: 'Examples';
		allCandidates: [ Smalltalk gtExamplesContained ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: false! !

!MorphicUIManager methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 8/13/2016 16:47'!
gtInform: aStringOrText send: aSelector to: anObject withValue: anArgument
	"Display a message for the user to read and then dismiss."
	(ProvideAnswerNotification signal: aStringOrText) ifNotNil: [ :answer | ^ self ].
	(GrowlMorph 
		openWithLabel: 'Information' translated 
		contents: aStringOrText)
			on: #mouseDown send: aSelector to: anObject withValue: anArgument.! !

!RBSelectorEnvironment methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 00:08'!
gtBrowseFor: aString
	| browser |
	metaClassSelectors keysAndValuesDo: [ :class :selectors | 
		classSelectors at: class ifAbsentPut: [ IdentitySet new ] ].
	browser := self browse.
	browser ui 
		title: aString; 
		packageSearchUpdate: ''.
	^ browser! !

!TClass methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/15/2016 20:19'!
gtInspectorGTExamplesIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list 
		title: 'Examples';
		display: [ self gtExamples ];
		icon: [:each | each icon];
		format: [ :each | each gtDisplayString ] ;
		send: [ :each | each returnValue ];
		when: [ self gtExamples notEmpty ]! !

!TClass methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 20:57'!
gtSpotterGTExampleSubjectsFor: aStep
	<spotterOrder: 101>
	aStep listProcessor
		title: 'Example Subject';
		items: [ { self asGTExampleSubject } ];
		itemName: [ :subject | subject gtDisplayString ];
		filter: GTFilterSubstring! !

!TClass methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 20:53'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 100>
	aStep listProcessor
		title: 'Examples';
		items: [ self gtExamples ];
		itemName: [ :example | example gtDisplayString ];
		filter: GTFilterSubstring! !

!GTExampleOrganizer methodsFor: '*GT-Examples-UI' stamp: 'TudorGirba 8/21/2016 07:22'!
gtInspectorExamplesIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Examples';
		display: [ self gtExamplesContained ];
		format: [ :each | each gtDisplayString ]! !

!CompiledMethod methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 20:57'!
gtSpotterGTExampleSubjectsFor: aStep
	<spotterOrder: 101>
	aStep listProcessor
		title: 'Example Subject';
		items: [ { self asGTExampleSubject } ];
		itemName: [ :subject | subject gtDisplayString ];
		filter: GTFilterSubstring! !

!CompiledMethod methodsFor: '*GT-Examples-UI' stamp: 'StefanReichhart 7/4/2016 20:53'!
gtSpotterGTExamplesFor: aStep
	<spotterOrder: 12>
	aStep listProcessor
		title: 'Examples';
		items: [ self gtExamples ];
		filter: GTFilterSubstring! !

GTAbstractExampleMethod subclass: #GTAbstractExampleMethodExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTAbstractExampleMethodExtension class methodsFor: 'testing' stamp: 'StefanReichhart 7/21/2016 14:47'!
isAbstract
	^ self == GTAbstractExampleMethodExtension! !

!GTAbstractExampleMethodExtension methodsFor: 'ui' stamp: 'StefanReichhart 7/21/2016 17:13'!
gtInspectorActionFor: aGTExample
	^ nil! !

!GTAbstractExampleMethodExtension methodsFor: 'ui' stamp: 'StefanReichhart 7/21/2016 14:51'!
gtInspectorFor: composite example: aGTExample! !

!GTAbstractExampleMethodExtension methodsFor: 'ui' stamp: 'StefanReichhart 7/21/2016 14:36'!
gtSpotterFor: aStep example: aGTExample! !

GTAbstractExampleMethodExtension subclass: #GTExampleMethodInspectorActionExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleMethodInspectorActionExtension methodsFor: 'ui' stamp: 'StefanReichhart 7/21/2016 17:13'!
gtInspectorActionFor: aGTExample
	^ self provider perform: self selector withArguments: { aGTExample }! !

GTAbstractExampleMethodExtension subclass: #GTExampleMethodInspectorExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleMethodInspectorExtension methodsFor: 'ui' stamp: 'StefanReichhart 7/21/2016 15:39'!
gtInspectorFor: aComposite example: aGTExample
	self provider perform: self selector withArguments: { aComposite. aGTExample }! !

GTAbstractExampleMethodExtension subclass: #GTExampleMethodSpotterExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleMethodSpotterExtension methodsFor: 'ui' stamp: 'StefanReichhart 7/21/2016 14:58'!
gtSpotterFor: aStep example: aGTExample
	self provider perform: self selector withArguments: { aStep. aGTExample }! !

Object subclass: #GTAbstractExampleMenu
	instanceVariableNames: 'lastItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTAbstractExampleMenu class methodsFor: 'menus' stamp: 'StefanReichhart 7/14/2016 17:29'!
menuFor: aBuilder
	self subclassResponsibility ! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 14:08'!
browseAllExamples: aBuilder
	(lastItem := aBuilder item: 'Browse all Examples')
		parent: #gte;
		keyText: 'e, a' if: Nautilus useOldStyleKeys not;
		action: [ GTExampleNavigation browseExamples ];
		icon: Smalltalk ui icons nautilus
! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 16:56'!
browseAllExamplesIgnoredByTests: aBuilder		
	(lastItem := aBuilder item: 'Browse all Examples ignored by Tests')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesIgnoredByTests ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 16:56'!
browseAllExamplesWithDependencies: aBuilder
	(lastItem := aBuilder item: 'Browse all Examples with Dependencies')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesWithDependencies ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 14:06'!
browseAllExamplesWithProblems: aBuilder		
	(lastItem := aBuilder item: 'Browse all Examples with Problems')
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesWithProblems ];
		icon: Smalltalk ui icons smallError.! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 20:01'!
browseExamplesReferencing: aLiteral builder: aBuilder	
	(lastItem := aBuilder item: 'Browse Examples referencing #' ,  aLiteral)
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesReferencing: aLiteral ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 8/6/2016 22:01'!
browseExamplesWithSubject: aLiteral builder: aBuilder
	(lastItem := aBuilder item: 'Browse Examples with subject #' ,  aLiteral gtDisplayString)
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesWithSubject: aLiteral ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 16:40'!
buildAllDependencies: aCollection builder: aBuilder with: aBlock
	^ (aBuilder item: #'Browse all Dependencies')
		parent: #gte;
		action: [ GTExampleNavigation browseAllDependenciesOf: aCollection ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 16:42'!
buildAllDependents: aCollection builder: aBuilder
	^ (aBuilder item: #'Browse all Dependents')
		parent: #gte;
		action: [ GTExampleNavigation browseAllDependentsOf: aCollection ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 16:40'!
buildDependencies: aCollection builder: aBuilder 
	^ (aBuilder item: #'Browse Dependencies')
		parent: #gte;
		action: [ GTExampleNavigation browseDependenciesOf: aCollection ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 16:41'!
buildDependents: aCollection builder: aBuilder
	^ (aBuilder item: #'Browse Dependents')
		parent: #gte;
		action: [ GTExampleNavigation browseDependentsOf: aCollection ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 16:57'!
buildSeparator
	lastItem ifNil: [ ^ self ].
	lastItem withSeparatorAfter! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 13:25'!
buildSubmenu: aBuilder
	(lastItem := aBuilder item: #gte)
		order: self submenuOrder;
		label: 'GT Examples';
		withSeparatorAfter.! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/22/2016 11:32'!
debugExamples: aBlock builder: aBuilder
	(lastItem := aBuilder item: 'Debug Examples')
		parent: #gte;
		keyText: 'e, d' if: Nautilus useOldStyleKeys not;
		action: [ self examples: aBlock withProgressCollect: [ :each | each debug ] ];
		icon: Smalltalk ui icons smallDebug.! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/15/2016 13:06'!
examples: aBlock
	self examples: aBlock select: [ :each | true ]! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/15/2016 13:03'!
examples: aBlock1 collect: aBlock2
	self examples: aBlock1 select: [ :each | true ] collect: [ :each | aBlock2 value: each ]! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/22/2016 11:34'!
examples: aCollection do: aBlock1 progress: aBlock2
	| progress |
	aCollection size < 2 ifTrue: [ ^ aCollection do: aBlock1 ].
	aBlock2 ifNil: [ ^ aCollection do: aBlock1 ].
	(progress := aBlock2 value: aCollection) isEmptyOrNil ifTrue: [ ^ aCollection do: aBlock1 ].
	aCollection do: aBlock1 displayingProgress: progress! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/15/2016 13:06'!
examples: aBlock1 select: aBlock2
	(aBlock1 value select: [ :example | 
		example isGTExample 
			and: [ aBlock2 value: example ] ])
				ifNotEmpty: [ :examples | 
					(examples size = 1 
						ifTrue: [ examples anyOne ]
						ifFalse: [ examples ]) inspect ]
				ifEmpty: [ self notifyNoExamples ]! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/15/2016 13:06'!
examples: aBlock1 select: aBlock2 collect: aBlock3
	| examples |
	examples := Dictionary new.
	aBlock1 value 
		select: [ :each | each isGTExample and: [ aBlock2 value: each ] ] 
		thenDo: [ :each | examples at: each put: (aBlock3 value: each) ].
	examples
		ifNotEmpty: [ examples inspect ]
		ifEmpty: [ self notifyNoExamples ]! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/22/2016 11:28'!
examples: aBlock1 select: aBlock2 collect: aBlock3 progress: aBlock4
	| results |
	results := Dictionary new.
	self examples: (aBlock1 value select: [ :each | each isGTExample and: [ aBlock2 value: each ] ]) 
		do: [ :each | results at: each put: (aBlock3 value: each) ]
		progress: aBlock4.
	results
		ifNotEmpty: [ results inspect ]
		ifEmpty: [ self notifyNoExamples ]! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/22/2016 11:33'!
examples: aBlock1 withProgressCollect: aBlock2
	self examples: aBlock1 
		select: [ :each | true ] 
		collect: [ :each | aBlock2 value: each ] 
		progress: [ :examples | 'Processing ' , examples size asString , ' examples ...' ]! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 14:03'!
inspectExamples: aBlock builder: aBuilder
	(lastItem := aBuilder item: 'Inspect Examples')
		parent: #gte;
		keyText: 'e, i' if: Nautilus useOldStyleKeys not;
		action: [ self examples: aBlock ];
		icon: Smalltalk ui icons glamorousInspect.! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 14:00'!
inspectProblems: aBlock builder: aBuilder
	(lastItem := aBuilder item: 'Inspect Problems')
		parent: #gte;
		action: [ self examples: aBlock select: [ :each | each hasProblems ] collect: [ :each | each problems ] ];
		icon: Smalltalk ui icons smallError! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/22/2016 11:35'!
inspectResults: aBlock builder: aBuilder
	(lastItem := aBuilder item: 'Inspect Results (full)')
		parent: #gte;
		action: [ self examples: aBlock withProgressCollect: [ :example | example result ] ].! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/22/2016 11:35'!
inspectReturnValue: aBlock builder: aBuilder
	(lastItem := aBuilder item: #'Inspect Return-Values')
		parent: #gte;
		keyText: 'e, v' if: Nautilus useOldStyleKeys not;
		action: [ self examples: aBlock withProgressCollect: [ :example | example returnValue ] ].! !

!GTAbstractExampleMenu methodsFor: 'public' stamp: 'StefanReichhart 7/14/2016 17:27'!
menuFor: aBuilder! !

!GTAbstractExampleMenu methodsFor: 'utils' stamp: 'StefanReichhart 7/15/2016 12:51'!
notifyNoExamples
	GrowlMorph 
		openWithLabel: 'GT Examples'
		contents: 'No examples found within the current selection' ! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/22/2016 11:32'!
runExamples: aBlock builder: aBuilder
	(lastItem := aBuilder item: 'Run Examples')
		parent: #gte;
		keyText: 'e, r' if: Nautilus useOldStyleKeys not;
		action: [ self examples: aBlock withProgressCollect: [ :each | each run ] ];
		icon: Smalltalk ui icons smallDoIt.! !

!GTAbstractExampleMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 13:35'!
submenuOrder
	^ -9999! !

GTAbstractExampleMenu subclass: #GTExampleNautilusClassMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleNautilusClassMenu class methodsFor: 'menus' stamp: 'StefanReichhart 7/14/2016 17:28'!
menuFor: aBuilder
	<contextMenu>
	<nautilusGlobalClassMenu>
	^ self new
		menuFor: aBuilder
		yourself! !

!GTExampleNautilusClassMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 17:14'!
browseClass: aClass builder: aBuilder
	(lastItem := aBuilder item: 'Browse Examples of Class ' ,  aClass name)
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesOfClass: aClass ].! !

!GTExampleNautilusClassMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 17:14'!
browseHierarchyOf: aClass builder: aBuilder
	(lastItem := aBuilder item: 'Browse Examples in Hierarchy of Class ' , aClass name)
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesInHierarchyOfClass: aClass ].! !

!GTExampleNautilusClassMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 17:14'!
browseSubclassesOf: aClass builder: aBuilder
	(lastItem := aBuilder item: 'Browse Examples in Subclasses of Class ' , aClass name)
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesInSubclassesOfClass: aClass ].! !

!GTExampleNautilusClassMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 17:14'!
browseSuperclassesOf: aClass builder: aBuilder
	(lastItem := aBuilder item: 'Browse Examples in Superclasses of Class ' , aClass name)
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesInSuperclassesOfClass: aClass ].! !

!GTExampleNautilusClassMenu methodsFor: 'public' stamp: 'StefanReichhart 8/6/2016 22:02'!
menuFor: aBuilder
	| model class |
	(model := aBuilder model) ifNil: [ ^ self ].
	(class := model selectedClass) ifNil: [ ^ self ].
	
	self buildSubmenu: aBuilder.
	self inspectExamples: [ class gtExamples ] builder: aBuilder.
	self inspectReturnValue: [ class gtExamples ] builder: aBuilder.
	self inspectResults: [ class gtExamples ] builder: aBuilder.
	self inspectProblems: [ class gtExamples ] builder: aBuilder.
	self buildSeparator.
	self runExamples: [ class gtExamples ] builder: aBuilder.
	self debugExamples: [ class gtExamples ] builder: aBuilder.
	self buildSeparator.
	self browseClass: class builder: aBuilder.
	self browseSubclassesOf: class builder: aBuilder.
	self browseSuperclassesOf: class builder: aBuilder.
	self browseHierarchyOf: class builder: aBuilder.
	self buildSeparator.
	self browseExamplesReferencing: class theNonMetaClass name builder: aBuilder.
	self browseExamplesWithSubject: class asGTExampleSubject builder: aBuilder.! !

!GTExampleNautilusClassMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 13:38'!
submenuOrder
	^ 1300! !

GTAbstractExampleMenu subclass: #GTExampleNautilusMethodMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleNautilusMethodMenu class methodsFor: 'menus' stamp: 'StefanReichhart 7/14/2016 17:28'!
menuFor: aBuilder
	<contextMenu>
	<nautilusGlobalMethodMenu>
	^ self new
		menuFor: aBuilder
		yourself! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 17:04'!
browseAfter: aCollection builder: aBuilder
	aCollection do: [ :after | 
		after forNautilus: [ :title :action | 
			(lastItem := aBuilder item: title)
				parent: #gte;
				action: [ action value ] ] ]! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 17:04'!
browseAllDependencies: aCollection builder: aBuilder
	(lastItem := aBuilder item: #'Browse all Dependencies')
		parent: #gte;
		action: [ GTExampleNavigation browseAllDependenciesOf: aCollection ]! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 17:05'!
browseAllDependents: aCollection builder: aBuilder
	(lastItem := aBuilder item: #'Browse all Dependents')
		parent: #gte;
		action: [ GTExampleNavigation browseAllDependentsOf: aCollection ]! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 17:05'!
browseDependencies: aCollection builder: aBuilder 
	(lastItem := aBuilder item: #'Browse Dependencies')
		parent: #gte;
		action: [ GTExampleNavigation browseDependenciesOf: aCollection ]! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 17:05'!
browseDependents: aCollection builder: aBuilder
	(lastItem := aBuilder item: #'Browse Dependents')
		parent: #gte;
		action: [ GTExampleNavigation browseDependentsOf: aCollection ]! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 14:03'!
browseExampleSubjects: aCollection builder: aBuilder
	(lastItem := aBuilder item: #'Browse Subjects')
		parent: #gte;
		action: [ GTExampleNavigation browseAllExampleSubjects: aCollection ];
		icon: Smalltalk ui icons glamorousDiveRight! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 17:05'!
browseSubjects: aCollection builder: aBuilder
	aCollection do: [ :subject | 
		subject forNautilus: [ :title :action | 			
			(lastItem := aBuilder item: title)
				parent: #gte;
				action: [ action value ] ] ]! !

!GTExampleNautilusMethodMenu methodsFor: 'public' stamp: 'StefanReichhart 8/6/2016 22:02'!
menuFor: aBuilder
	| model method examples |
	(model := aBuilder model) ifNil: [ ^ self ].
	(method := model selectedMethod) ifNil: [ ^ self ].
	examples := method gtExamples reject: [ :each | each isNil ].
	
	self buildSubmenu: aBuilder.
	examples ifNotEmpty: [ 
		| problems arguments subjects afters |
		problems := (examples gather: [ :each | each problems ]) reject: [ :each | each isNil ].
		arguments := (examples gather: [ :each | each arguments ]) reject: [ :each | each isNil ].
		afters := (examples collect: [ :each | each after ]) reject: [ :each | each isNil ].
		subjects := (examples gather: [ :each | each subjects ]) reject: [ :each | each isNil ].
		self inspectExamples: [ examples ] builder: aBuilder.
		self inspectReturnValue: [ examples ] builder: aBuilder.
		self inspectResults: [ examples ] builder: aBuilder.
		problems ifNotEmpty: [
			self inspectProblems: [ examples ] builder: aBuilder.
			self buildSeparator ].
		self buildSeparator.
		self runExamples: [ examples ] builder: aBuilder.
		self debugExamples: [ examples ] builder: aBuilder.
		self buildSeparator.
		arguments ifNotEmpty: [
			self browseDependencies: examples builder: aBuilder.
			self browseDependents: examples builder: aBuilder.
			self buildSeparator.
			self browseAllDependencies: examples builder: aBuilder.
			self browseAllDependents: examples builder: aBuilder.
			self buildSeparator ].
		self buildSeparator.
		afters ifNotEmpty: [ 
			self browseAfter: afters builder: aBuilder.
			self buildSeparator ].
		self buildSeparator.
		subjects ifNotEmpty: [ 
			self browseExampleSubjects: examples builder: aBuilder.
			self browseSubjects: subjects builder: aBuilder.
			self buildSeparator ].
		self buildSeparator ].
	self browseExamplesReferencing: method selector builder: aBuilder.
	self browseExamplesWithSubject: method asGTExampleSubject builder: aBuilder.! !

!GTExampleNautilusMethodMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 13:33'!
submenuOrder
	^ 1450! !

GTAbstractExampleMenu subclass: #GTExampleNautilusPackageMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleNautilusPackageMenu class methodsFor: 'menus' stamp: 'StefanReichhart 7/14/2016 17:29'!
menuFor: aBuilder
	<contextMenu>
	<nautilusGlobalPackageMenu>
	^ self new
		menuFor: aBuilder
		yourself! !

!GTExampleNautilusPackageMenu methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 17:06'!
browsePackage: aPackage builder: aBuilder
	(lastItem := aBuilder item: #'Browse all Examples of Package ' ,  aPackage packageName)
		parent: #gte;
		action: [ GTExampleNavigation browseExamplesOfPackage: aPackage ]! !

!GTExampleNautilusPackageMenu methodsFor: 'public' stamp: 'StefanReichhart 8/6/2016 22:01'!
menuFor: aBuilder
	| model node package |
	(model := aBuilder model) ifNil: [ ^ self ].
	(node := model selectedPackage) ifNil: [ ^ self ].
	(package := node item) ifNil: [ ^ self ].
	
	self buildSubmenu: aBuilder.
	self inspectExamples: [ package gtExamplesContained ] builder: aBuilder.
	self inspectReturnValue: [ package gtExamplesContained ] builder: aBuilder.
	self inspectResults: [ package gtExamplesContained ] builder: aBuilder.
	self inspectProblems: [ package gtExamplesContained ] builder: aBuilder.
	self buildSeparator.
	self runExamples: [ package gtExamplesContained ] builder: aBuilder.
	self debugExamples: [ package gtExamplesContained ] builder: aBuilder.
	self buildSeparator.
	self browsePackage: package builder: aBuilder.
	self buildSeparator.
	self browseExamplesReferencing: package packageName  builder: aBuilder.
	self browseExamplesWithSubject: package asGTExampleSubject builder: aBuilder.! !

!GTExampleNautilusPackageMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 13:35'!
submenuOrder
	^ 1010! !

GTAbstractExampleMenu subclass: #GTExampleRubEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleRubEditor class methodsFor: 'menus' stamp: 'StefanReichhart 8/6/2016 21:28'!
menuFor: aBuilder
	<contextMenu>
	<RubSmalltalkCodeMenu>
	^ self new
		menuFor: aBuilder
		yourself! !

!GTExampleRubEditor methodsFor: 'public' stamp: 'StefanReichhart 8/6/2016 22:08'!
menuFor: aBuilder
	| selection selectedText selectedString |
	aBuilder model ifNil: [ ^ self ].
	aBuilder model model ifNil: [ ^ self ].
	(selection := aBuilder model selectionInterval) isEmptyOrNil ifTrue: [ ^ self ].
	(selectedText := aBuilder model text copyFrom: selection first to: selection last) isEmptyOrNil ifTrue: [ ^ self ].
	(selectedString := selectedText asString) isEmptyOrNil ifTrue: [ ^ self ].
	
	(lastItem := aBuilder item: 'GT Examples')
		withSeparatorAfter;
		with: [ 
			(lastItem := aBuilder item: #'Browse Examples with subject #' , selectedString)
				action: [ GTExampleNavigation browseExamplesWithSubjectMatching: selectedString ].
			(lastItem := aBuilder item: #'Browse Examples with literal #' , selectedString)
				action: [ GTExampleNavigation browseExamplesLiteralThorough: selectedString asSymbol ]. ]! !

GTAbstractExampleMenu subclass: #GTExampleWorldMenu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleWorldMenu class methodsFor: 'menus' stamp: 'StefanReichhart 7/15/2016 13:19'!
menuFor: aBuilder
	<worldMenu>
	^ self new 
		menuFor: aBuilder;
		yourself! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 13:49'!
buildSubmenu: aBuilder
	(lastItem := aBuilder item: #gte)
		order: 0.15;
		parent: 'Tools';
		label: 'GT Examples';
		withSeparatorAfter.! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 18:03'!
disableNotifications: aBuilder
	(lastItem := aBuilder item: 'Disable Notifications')
		parent: #gte;
		action: [ GTExampleNautilusNotifications stop ]! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 18:05'!
enableNotifications: aBuilder
	(lastItem := aBuilder item: 'Enable Notifications')
		parent: #gte;
		action: [ GTExampleNautilusNotifications start ]! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 14:06'!
inspectAllExamples: aBuilder
	(lastItem := aBuilder item: 'Inspect all Examples')
		parent: #gte;
		action: [ self examples: [ Smalltalk gtExamplesContained ] ];
		icon: Smalltalk ui icons glamorousInspect.! !

!GTExampleWorldMenu methodsFor: 'public' stamp: 'StefanReichhart 7/21/2016 18:00'!
menuFor: aBuilder
	self buildSubmenu: aBuilder.
	
	self inspectAllExamples: aBuilder.
	
	self buildSeparator.
	
	self browseAllExamples: aBuilder.
	self browseAllExamplesWithProblems: aBuilder.
	self browseAllExamplesWithDependencies: aBuilder.
	self browseAllExamplesIgnoredByTests: aBuilder.
	
	self buildSeparator.
	
	self toggleNotifications: aBuilder.
	
	self buildSeparator.
	
	self resetAllExamples: aBuilder! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 17:57'!
resetAllExamples
	GTExampleOrganizer reset.
	GTExampleOrganizer restart.
	Smalltalk garbageCollect.! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 17:59'!
resetAllExamples: aBuilder
	(lastItem := aBuilder item: 'Reset all Examples')
		parent: #gte;
		action: [ self resetAllExamples ]! !

!GTExampleWorldMenu methodsFor: 'private' stamp: 'StefanReichhart 7/21/2016 18:02'!
toggleNotifications: aBuilder
	GTExampleNautilusNotifications isEnabled
		ifTrue: [ self disableNotifications: aBuilder ]
		ifFalse: [ self enableNotifications: aBuilder ]! !

Object subclass: #GTExampleGraphPainter
	instanceVariableNames: 'example view group edges nodes fromTo processing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleGraphPainter methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 11:08'!
buildAfter: anExample1
	| shape element parentNode edge line |
	
	" abort if we've done this already "
	anExample1 after ifNil: [ ^ self ].
	(nodes includesKey: anExample1 after) ifTrue: [ ^ self ].
	
	" add element and shape "
	shape := RTEllipse new 
		width: 8;
		height: 8;
		color: Color white;
		borderColor: (anExample1 after isValid 
			ifTrue: [ Color black ]
			ifFalse: [ Color yellow alpha: 0.05 ]);
		borderWidth: 1;
		yourself.
	element := shape elementOn: anExample1.
	group add: element.
	nodes at: anExample1 after put: { element. shape }.
	
	" add edge "
	parentNode := nodes at: anExample1.
	edge := RTEdge from: parentNode first to: element.
	line := RTLine new 
		color: (anExample1 after isValid 
			ifTrue: [ Color black ]
			ifFalse: [ Color yellow ]); 
		attachPoint: RTVerticalAttachPoint instance;
		yourself.
	edge + line.
	edges add: edge! !

!GTExampleGraphPainter methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 11:46'!
buildArgument: anExample1 at: index parent: anExample2
	| shape element parentNode edge line |
	(nodes includesKey: anExample1) 
		ifTrue: [ 
			" retrieve existing element and shape"
			element := (nodes at: anExample1) first.
			shape := (nodes at: anExample1) second. ]
		ifFalse: [ 
			" add element and shape "
			shape := RTBox new 
				width: 8;
				height: 8;
				color: Color white;
				borderColor: (Color black alpha: 0.05);
				borderWidth: 4;
				yourself.
			element := shape elementOn: anExample1.
			group add: element.
			nodes at: anExample1 put: { element. shape } ].
	
	" add edge if not already present "
	self edgeFrom: anExample2 to: anExample1 ifAbsent: [ 
		parentNode := nodes at: anExample2.
		edge := RTEdge from: parentNode first to: element.
		line := RTArrowedLine new 
			color: Color yellow; 
			attachPoint: RTVerticalAttachPoint instance;
			yourself.
		edge + line.
		edges add: edge ]! !

!GTExampleGraphPainter methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 12:02'!
buildDependencies: anExampleOrMethod1 at: index parent: anExampleOrMethod2
	self process: anExampleOrMethod1 
		do: [ 
			anExampleOrMethod1 isGTExample 
				ifTrue: [ 
					" example with all dependencies "
					self buildDependency: anExampleOrMethod1 at: index parent: anExampleOrMethod2.
					anExampleOrMethod1 dependenciesOrArguments withIndexDo: [ :dep :depIndex | 
						self buildDependencies: dep at: depIndex parent: anExampleOrMethod1 ].
					self buildAfter: anExampleOrMethod1 ]
				ifFalse: [ 
					" just an argument (placeholder) - example missing "
					self buildArgument: anExampleOrMethod1 at: index parent: anExampleOrMethod2 ] ] 
		onRecursionDo: [ 
			self updateDependency: anExampleOrMethod1 at: index parent: anExampleOrMethod2 ]
! !

!GTExampleGraphPainter methodsFor: 'private' stamp: 'TudorGirba 8/22/2016 02:59'!
buildDependency: anExample1 at: index parent: anExample2
	| shape element parentNode edge line |
	(nodes includesKey: anExample1) 
		ifTrue: [ 
			" retrieve existing element and shape"
			element := (nodes at: anExample1) first.
			shape := (nodes at: anExample1) second. ]
		ifFalse: [ 
			" add element and shape "
			shape := RTBox new 
				width: 16;
				height: 16;
				color: (self example == anExample1 ifTrue: [ Color lightGray ] ifFalse: [ Color white ]);
				borderColor: (anExample1 hasInternalProblems
					ifTrue: [ Color yellow ]
					ifFalse: [ Color black ]);
				borderWidth: 4;
				yourself.
			element := shape elementOn: anExample1.
			group add: element.
			nodes at: anExample1 put: { element. shape }.
			" add missing arguments "
			self buildMissingArguments: anExample1 ].
	
	" add edge if not already present "
	self edgeFrom: anExample2 to: anExample1 ifAbsent: [ 
		parentNode := nodes at: anExample2.
		edge := RTEdge from: parentNode first to: element.
		line := RTArrowedLine new 
			color: (index > anExample2 method numArgs 
				ifTrue: [ Color yellow ] 
				ifFalse: [ Color lightGray ]); 
			attachPoint: RTVerticalAttachPoint instance;
			yourself.
		edge + line.
		edges add: edge ]! !

!GTExampleGraphPainter methodsFor: 'private' stamp: 'TudorGirba 8/22/2016 02:58'!
buildDependent: anExample1 child: anExample2
	| shape element childNode edge line |
	(nodes includesKey: anExample1) 
		ifTrue: [ 
			" retrieve existing element and shape"
			element := (nodes at: anExample1) first.
			shape := (nodes at: anExample1) second. ]
		ifFalse: [
			" add element and shape "
			shape := RTBox new 
				width: 16;
				height: 16;
				color: (self example == anExample1 ifTrue: [ Color lightGray ] ifFalse: [ Color white ]);
				borderColor: (anExample1 hasInternalProblems
					ifTrue: [ Color yellow ]
					ifFalse: [ Color black ]);
				borderWidth: 4;
				yourself.
			element := shape elementOn: anExample1.
			group add: element.
			nodes at: anExample1 put: { element. shape } ].
	
	" add edge if not already present "
	self edgeFrom: anExample1 to: anExample2 ifAbsent: [ 
		childNode := nodes at: anExample2.
		edge := RTEdge from: element to: childNode first.
		line := RTArrowedLine new 
			color: Color lightGray; 
			attachPoint: RTVerticalAttachPoint instance;
			yourself.
		edge + line.
		edges add: edge ]! !

!GTExampleGraphPainter methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 12:04'!
buildDependents: anExampleOrMethod1 child: anExampleOrMethod2
	self process: anExampleOrMethod1 
		do: [ 
			anExampleOrMethod1 directDependents do: [ :dep |
				self buildDependent: dep child: anExampleOrMethod1.
				self buildDependents: dep child: anExampleOrMethod1 ] ] 
		onRecursionDo: [ 
			self updateDependent: anExampleOrMethod1 child: anExampleOrMethod2 ]! !

!GTExampleGraphPainter methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 11:42'!
buildMissingArguments: anExample1
	| method |
	
	" abort if we've done this already "
	method := anExample1 method.
	method numArgs > anExample1 arguments size ifFalse: [ ^ self ].
	
	(1 max: anExample1 arguments size) to: method numArgs  do: [ :index |
		| shape argumentName element edge line |
		" add shape "
		shape := RTBox new 
			width: 8;
			height: 8;
			color: Color white;
			color: Color white;
			borderWidth: 4;
			yourself.
		argumentName := method argumentNames at: index.
		element := shape elementOn: argumentName asString.
		group add: element.
		
		" add edge "
		edge := RTEdge from: (nodes at: anExample1) first to: element.
		line := RTArrowedLine new 
			color: Color yellow; 
			attachPoint: RTVerticalAttachPoint instance;
			yourself.
		edge + line.
		edges add: edge ]! !

!GTExampleGraphPainter methodsFor: 'private-utils' stamp: 'StefanReichhart 7/15/2016 11:45'!
edgeFrom: fromExample to: toExample ifAbsent: aBlock
	| processedEdges |
	fromExample ifNil: [ ^ self ].
	toExample ifNil: [ ^ self ].
	processedEdges := fromTo at: fromExample ifAbsentPut: [ Set new ].
	(processedEdges includes: toExample) ifTrue: [ ^ self ].
	[ aBlock value ] ensure: [ 
		processedEdges add: toExample ]! !

!GTExampleGraphPainter methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2016 14:31'!
example
	^ example! !

!GTExampleGraphPainter methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2016 14:31'!
example: anObject
	example := anObject! !

!GTExampleGraphPainter methodsFor: 'public' stamp: 'StefanReichhart 7/15/2016 11:44'!
paint
	group := RTGroup new.
	edges := OrderedCollection new.
	fromTo := Dictionary new.
	nodes := Dictionary new.
	processing := Set new.
	self buildDependencies: self example at: nil parent: nil.
	self buildDependents: self example child: nil.
	view addAll: group @ (RTPopup text: [ :node | node gtDisplayString ]) @ RTDraggable.
	view addAll: edges.
	RTTreeLayout new on: group.
	^ view! !

!GTExampleGraphPainter methodsFor: 'private-utils' stamp: 'StefanReichhart 7/15/2016 12:00'!
process: aGTExample do: aBlock onRecursionDo: aBlock2
	(processing includes: aGTExample) ifTrue: [ ^ aBlock2 value ].
	processing add: aGTExample.
	[ aBlock value ] ensure: [ 
		processing remove: aGTExample ]! !

!GTExampleGraphPainter methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 11:43'!
updateDependency: anExampleOrMethod1 at: index parent: anExampleOrMethod2
	| node parentNode edge line |
	
	" abort if we've done this already "
	self edgeFrom: anExampleOrMethod2 to: anExampleOrMethod1 ifAbsent: [ 
		" retrieve existing elements "
		node := nodes at: anExampleOrMethod1.
		parentNode := nodes at: anExampleOrMethod2.
		
		" add edge "
		edge := RTEdge from: parentNode first to: node first.
		line := RTArrowedLine new 
			color: Color red; 
			attachPoint: RTVerticalAttachPoint instance;
			yourself.
		edge + line.
		edges add: edge ]! !

!GTExampleGraphPainter methodsFor: 'private' stamp: 'StefanReichhart 7/15/2016 11:43'!
updateDependent: anExampleOrMethod1 child: anExampleOrMethod2
	| node parentNode edge line |
	
	" abort if we've done this already "
	self edgeFrom: anExampleOrMethod1 to: anExampleOrMethod2 ifAbsent: [ 
		" retrieve existing elements "
		node := nodes at: anExampleOrMethod2.
		parentNode := nodes at: anExampleOrMethod1.
		
		" add edge "
		edge := RTEdge from: parentNode first to: node first.
		line := RTArrowedLine new 
			color: Color red; 
			attachPoint: RTVerticalAttachPoint instance;
			yourself.
		edge + line.
		edges add: edge ]! !

!GTExampleGraphPainter methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2016 14:39'!
view
	^ view! !

!GTExampleGraphPainter methodsFor: 'accessing' stamp: 'StefanReichhart 7/13/2016 14:39'!
view: anObject
	view := anObject! !

Object subclass: #GTExampleNautilusNotifications
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

GTExampleNautilusNotifications class
	instanceVariableNames: 'notifying'!

GTExampleNautilusNotifications class
	instanceVariableNames: 'notifying'!

!GTExampleNautilusNotifications class methodsFor: 'private' stamp: 'StefanReichhart 7/5/2016 14:57'!
changed: anAnnouncement
	| examples |
	examples := Smalltalk gtExamplesContained select: [ :example | example hasProblems ].
	examples size > 4 ifTrue: [ ^ self notifyExamples: examples ].
	examples do: [ :example | self notifyExample: example ]! !

!GTExampleNautilusNotifications class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 09:58'!
example: aGTExample event: anEvent from: anEventSource
	GTExampleNavigation browse: 'Examples with Problems' examples: { aGTExample }! !

!GTExampleNautilusNotifications class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 09:58'!
examples: aCollection event: anEvent from: anEventSource
	GTExampleNavigation browse: 'Examples with Problems' examples: aCollection! !

!GTExampleNautilusNotifications class methodsFor: 'actions' stamp: 'StefanReichhart 7/21/2016 18:02'!
isEnabled
	^ notifying == true! !

!GTExampleNautilusNotifications class methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 16:19'!
notifyExample: aGTExample
	UIManager default 
		gtInform: 'Example ', aGTExample gtDisplayString , ' is invalid' , String cr, ' (click to browse)'
		send: #example:event:from:
		to: self
		withValue: aGTExample! !

!GTExampleNautilusNotifications class methodsFor: 'private' stamp: 'StefanReichhart 7/14/2016 16:19'!
notifyExamples: aCollection
	UIManager default 
		gtInform: 'There are ' , aCollection size asString , ' invalid examples' , String cr, ' (click to browse)'
		send: #examples:event:from:
		to: self
		withValue: aCollection! !

!GTExampleNautilusNotifications class methodsFor: 'private' stamp: 'StefanReichhart 7/5/2016 15:00'!
registerInterestToSystemAnnouncement
	<systemEventRegistration>
	
	self restart! !

!GTExampleNautilusNotifications class methodsFor: 'actions' stamp: 'StefanReichhart 7/5/2016 11:52'!
restart
	" self restart "
	self stop.
	self start.! !

!GTExampleNautilusNotifications class methodsFor: 'actions' stamp: 'StefanReichhart 7/12/2016 10:59'!
start
	" self start "
	notifying == true ifTrue: [ ^ self ].
	SystemAnnouncer uniqueInstance weak 
		when: GTExamplesModifiedAnnouncement send: #changed: to: self.
	notifying := true! !

!GTExampleNautilusNotifications class methodsFor: 'actions' stamp: 'StefanReichhart 7/5/2016 15:01'!
stop
	" self stop "
	SystemAnnouncer uniqueInstance unsubscribeThoroughly: self.
	Announcer allSubInstances do: [ :each | each unsubscribeThoroughly: self ].
	notifying := false! !

Object subclass: #GTExampleNavigation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Examples-UI'!

!GTExampleNavigation class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 09:56'!
browse: aString examples: aCollection
	| env |
	env := RBSelectorEnvironment new.
	aCollection do: [ :example |
		env addClass: example methodClass selector: example selector ].
	env isEmpty 
		ifTrue: [ ^ UIManager default inform: 'No examples found' ].
	^ env gtBrowseFor: aString! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:14'!
browseAllDependenciesOf: aCollectionOfExamples
	self browse: 'Dependencies' examples: (aCollectionOfExamples gather: [ :each | each allDependencies ])! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:16'!
browseAllDependentsOf: aCollectionOfExamples
	self browse: 'All Dependents' examples: (aCollectionOfExamples gather: [ :each | each allDependents ])! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 09:55'!
browseAllExampleAfterMethods: aCollectionOfExamples
	" self browseAllExampleAfterMethods: GTExample "
	| env |
	env := RBSelectorEnvironment new.
	aCollectionOfExamples do: [ :example | 
		example after ifNotNil: [
			example after addToSelectorEnvironment: env ] ].
	^ env gtBrowseFor: 'After Methods'! !

!GTExampleNavigation class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 09:55'!
browseAllExampleSubjects: aCollectionOfExamples
	" self browseAllExamplesWithSubject: GTExample "
	| env |
	env := RBSelectorEnvironment new.
	aCollectionOfExamples do: [ :example | 
		example subjects do: [ :subject | 
			subject ifNotNil: [ 
				subject addToSelectorEnvironment: env ] ] ].
	^ env gtBrowseFor: 'Subjects'! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:08'!
browseDependenciesOf: aCollectionOfExamples
	self browse: 'Dependencies' examples: (aCollectionOfExamples gather: [ :each | each dependencies ])! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:16'!
browseDependentsOf: aCollectionOfExamples
	self browse: 'Dependents' examples: (aCollectionOfExamples gather: [ :each | each directDependents ])! !

!GTExampleNavigation class methodsFor: 'browse globally' stamp: 'StefanReichhart 7/13/2016 10:12'!
browseExamples
	" self browseAllExamples "
	self browseExamples: 'Examples' select: [ :example | true ]! !

!GTExampleNavigation class methodsFor: 'private' stamp: 'StefanReichhart 7/13/2016 09:56'!
browseExamples: aString select: aBlock
	^ self browse: aString examples: (Smalltalk gtExamplesContained select: [ :example | aBlock value: example ])! !

!GTExampleNavigation class methodsFor: 'browse globally' stamp: 'StefanReichhart 7/13/2016 10:12'!
browseExamplesIgnoredByTests
	" self browseAllExamplesIgnoredByTests "
	self browseExamples: 'Examples ignored by Tests' select: [ :example | 
		example ignoreTest 
			or: [ example ignoreTestReport ] ]! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:12'!
browseExamplesInHierarchyOfClass: aClass
	self browse: 'Examples in Hierarchy of Class ' , aClass name examples: (aClass withAllSubclasses gather: [ :each | each gtExamples ]), (aClass allSuperclasses gather: [ :each | each gtExamples ])! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:12'!
browseExamplesInSubclassesOfClass: aClass
	self browse: 'Examples in Subclasses of Class ' , aClass name examples: (aClass withAllSubclasses gather: [ :each | each gtExamples ])! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:12'!
browseExamplesInSuperclassesOfClass: aClass
	self browse: 'Examples in Superclasses of Class ' , aClass name examples: (aClass withAllSuperclasses gather: [ :each | each gtExamples ])! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/6/2016 21:53'!
browseExamplesLiteralThorough: aString
	" self browseExamplesLiteralThorough: #and: "
	self browseExamples: 'Examples with literal #', aString select: [ :example | 
		example hasLiteralThorough: aString ]! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:10'!
browseExamplesOfClass: aClass
	self browse: 'Examples of Class ' , aClass name examples: aClass gtExamples! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:15'!
browseExamplesOfPackage: anRPackage
	self browse: 'Examples of Package ' , anRPackage packageName examples: anRPackage gtExamplesContained! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:12'!
browseExamplesReferencing: aLiteral
	" self browseAllExamplesReferencing: #and: "
	self browseExamples: 'Examples referencing #', aLiteral asString select: [ :example | 
		example isReferencing: aLiteral ]! !

!GTExampleNavigation class methodsFor: 'browse globally' stamp: 'StefanReichhart 7/13/2016 10:12'!
browseExamplesWithDependencies
	" self browseAllExamplesWithDependencies "
	self browseExamples: 'Examples with Dependencies' select: [ :example | 
		example hasArguments ]! !

!GTExampleNavigation class methodsFor: 'browse globally' stamp: 'StefanReichhart 7/15/2016 12:18'!
browseExamplesWithProblems
	" self browseExamplesWithProblems "
	self browseExamples: 'Examples with Problems' select: [ :example | 
		example hasProblems ]! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 7/13/2016 10:12'!
browseExamplesWithSubject: aGTExampleSubject
	" self browseAllExamplesWithSubject: GTExample "
	self browseExamples: 'Examples with Subject ', aGTExampleSubject gtDisplayString select: [ :example | 
		example hasSubject: aGTExampleSubject ]! !

!GTExampleNavigation class methodsFor: 'browse with scope' stamp: 'StefanReichhart 8/6/2016 22:02'!
browseExamplesWithSubjectMatching: aGTExampleSubject
	" self browseAllExamplesWithSubject: GTExample "
	self browseExamples: 'Examples with Subject ', aGTExampleSubject gtDisplayString select: [ :example | 
		example hasSubjectMatching: aGTExampleSubject ]! !

!Object methodsFor: '*GT-Examples-UI' stamp: 'TudorGirba 1/27/2016 00:18'!
gtExampleSourceIn: composite inContext: aGTInspector
	<gtInspectorPresentationOrder: 100>
	| previousRawSelection |
	"we first check to see if we have at least two panes, because only
	if we have two panes does it make sense to check the raw selection of the previous pane"
	((aGTInspector isKindOf: GTInspector) and: [aGTInspector first panes size >= 2]) ifFalse: [ ^ self ].
	
	previousRawSelection := (aGTInspector first panes reverse second port: #rawSelection) value.
	previousRawSelection isGTExample ifTrue: [ 
		previousRawSelection gtInspectorSourceIn: composite ]! !
